using System;
using Syntriax.Modules.State;

namespace Syntriax.Modules.Trigger
{
    public interface ITrigger
    {
        /// <summary>
        /// <see cref="IStateEnable"/> to control the state of the <see cref="ITrigger"/> is on or off
        /// </summary>
        IStateEnable StateEnable { get; }

        /// <summary>
        /// Called everytime the IsTrigerred field is changed
        /// </summary>
        /// <value>The new value of IsTrigerred</value>
        Action<bool> OnTriggerStateChanged { get; set; }

        bool IsTrigerred { get; }
    }
}
